/*
 *	MyGLCanvas.h
 *	OpenGL Demo
 *
 *	Created by Ross Ashman on Jan 1 2005.
 *	Copyright (c) 2005 Ross Ashman. All rights reserved.
 *
 */

// MyGLCanvas.h: interface for the wxMyGLCanvas class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _MYGLCANVAS_H__INCLUDED_
#define _MYGLCANVAS_H__INCLUDED_

#include <wx/glcanvas.h>
#include <wx/gdicmn.h>

#include "BezierCurve.h"

class MyGLCanvas : public wxGLCanvas  
{
public:
	MyGLCanvas(wxWindow* parent,wxPanel *_panel, 
                   wxWindowID id = -1, 
                   const wxPoint& pos = wxDefaultPosition, 
                   const wxSize& size = wxDefaultSize, 
                   long style=0, 
                   const wxString& name="GLCanvas",
                   int* attribList = 0, 
                   const wxPalette& palette = wxNullPalette);
	virtual ~MyGLCanvas();

	// Methods
	void InitGL();
    void Draw();
    void Paint(wxDC &dc);
    
    void Clear(); //izbrise ekran i ponisti sve kontrolne tocke u krivulji
	// Event Handlers (These Functions Should NOT be Virtual)
	
    void OnPaint(wxPaintEvent& event);
	void OnLeftMouse(wxMouseEvent& event);
	void OnLeftMouseUp(wxMouseEvent& event);
	void OnRightMouse(wxMouseEvent& event);
	void OnRightMouseUp(wxMouseEvent& event);
	void OnMouseMove(wxMouseEvent& event);
	void OnSize(wxSizeEvent& event);
	void OnEraseBackground(wxEraseEvent& event);
	void OnIdle(wxIdleEvent& event);
	
	BezierCurve bezier;

protected:

private:
	//DECLARE_CLASS(wxGLViewCanvas)
	// any class wishing to process wxWindows events must use this macro
	DECLARE_EVENT_TABLE()
      float RotX, RotY, Depth;
      long Xcoord, Ycoord, Zcoord, Dummy, X, Y;
      int MouseButton;
      struct MyColor {
        float R;
        float G;
        float B;
        } OColor, BColor;
      wxPanel *panel;
      wxStaticText *testLabel;
      wxCheckBox *WxCheckBoxRotation;
      bool drag_point; //tu pamtim pomicem li tocku poligona kad korisnik vuce mis i drzi lijevu tipku
      int drag_point_index;
      //wxCheckBox *WxCheckBoxZoom;
    
      
};

#endif // _MYGLCANVAS_H__INCLUDED_
